#pragma once

namespace MetaData
{
    class AI;
}

enum ShotType_e
{
   kShotNone = 0,
   kShotClick = 1,
   kShotHold = 2,
};

class MoveableEntity;
class AIComponent
{
 public:
    MoveableEntity* owner = nullptr;
    MetaData::AI* ai_meta = nullptr;

    virtual ~AIComponent();
    virtual void Update(int delta_time);
    virtual float GetAttackRate() { return 0;};
    virtual void Reset() {};

};
