#pragma once

#include "human.h"

namespace MetaData
{
    class Robot;
}

class AIComponent;
class Android : public Human
{
 public:
    MetaData::Robot* robot_meta = nullptr;

    virtual ~Android() override;
    virtual void Initialize() override;
    virtual void Update(int delta_time) override;
    void GiveEquip();
    void SetAiLevel(int ai_level);

protected:
    Android();

private:
    void InternalUpdate(int delta_time);
    void RandSkin();

    friend class EntityFactory;
};
