#pragma once

extern int g_hint_flags;

class ColliderComponent;
class Global : public a8::Singleton<Global>
{
 private:
    Global() {};
    friend class a8::Singleton<Global>;
 public:

    static int g_nowtime;
    static ColliderComponent* last_collider;
    int traversing_cell_creature_count = 0;
};

bool IsValidSlotId(int slot_id);
bool IsValidBuffEffect(int buff_effect);
bool IsValidHumanAttr(int attr_type);
bool IsValidCondBuff(int cond);
bool IsValidWeaponOpt(int opt);
bool IsValidBuffOpt(int opt);
