#pragma once

#include <a8/xtimer.h>

class Human;
class Room;
class Incubator
{
 public:
    Room* room = nullptr;

    void Init();
    void UnInit();
    void AllocAndroid(Human* target, int num);
    void RecycleAndroid(Human* hum);
    void ActiveAndroid(Human* hum, Human* android);

private:
    bool CanSee(Human* hum, Human* exclude_hum);
    void AutoAllocAndroid();

private:
    std::vector<Human*> hold_humans_;
    a8::XTimerAttacher xtimer_attacher_;
};
