#pragma once

class PerfMonitor : public a8::Singleton<PerfMonitor>
{
 private:
    PerfMonitor() {};
    friend class a8::Singleton<PerfMonitor>;

 public:
    int max_run_delay_time = 0;
    int max_dispatchmsg_time = 0;
    int max_timer_idle = 0;
    long long out_data_size = 0;
    long long in_data_size = 0;
    long long read_count = 0;
    long long grid_chg_times = 0;
    long long test_times = 0;
    long long alive_count = 0;
    long long real_alive_count = 0;
    std::array<long long, 30> params = {};
    std::array<int, 30> entity_num = {};
    std::array<int, RT_Max + 1> room_num = {};
    int max_full_objects_num = 0;
    int max_part_objects_num = 0;
    int max_bullet_num = 0;

    int his_max_full_objects_num = 0;
    int his_max_part_objects_num = 0;
    int his_max_bullet_num = 0;

    void Init();
    void UnInit();
};
