#pragma once

class Room;
class Human;
class Team
{
 public:
    Room* room = nullptr;

    void SetInitTeamMemberNum(int init_num) { init_team_member_num_ = init_num; };
    void SetAutoFill(bool auto_fill) { auto_fill_ = auto_fill; };
    bool IsAutoFill() { return auto_fill_; };
    int GetTeamId() { return team_id_; }
    void SetTeamId(int team_id) { team_id_ = team_id; }
    void TraverseMembers(std::function<bool (Human*)> func);
    size_t GetMemberNum() { return members_.size(); }
    void GetOveredHumans(std::set<Human*>& overed_humans);
    Human* GetOneAliveMember(Human* exclude_hum);
    bool HasAliveMember();
    int GetAliveNum();
    void AddMember(Human* member);
    bool IsFull();
    void CombineBornPoint();
    void CombineTeam(Team* b_team);
    bool CanCombine(Human* member);
    void AddCombineMemberNum(int member_num);
    Human* GetMemberByUniId(int member_id);
    int GetInitTeamMemberNum() { return init_team_member_num_; };

 private:
    int team_id_ = 0;
    int init_team_member_num_ = 0;
    int combined_team_member_num_ = 0;
    std::set<Human*> members_;
    Human* first_member_ = nullptr;
    bool auto_fill_ = false;
};
