#pragma once

#include "entity.h"

namespace metatable
{
    class MapBlockJson;
}

class MapInstance;
class MapService;
class DummyEntity : public Entity
{
 public:
    MapService* permanent_map_service = nullptr;
    std::list<metatable::MapBlockJson>* blocks = nullptr;

    virtual void Initialize() override;
    virtual void OnBulletHit(Bullet* bullet) override;
    virtual void OnExplosionHit(Explosion* explosion) override;

};
