#pragma once

#include "microtask.h"

namespace MetaData
{
    struct Buff;
    struct Equip;
}

class Room;
class Player;
class FragMiTask : public MicroTask
{
 public:
    Room* room = nullptr;
    a8::Vec2 bomb_pos;
    CreatureWeakPtr sender;
    CreatureWeakPtr follow_target;
    CreatureWeakPtr force_target;
    MetaData::Equip* gun_meta = nullptr;
    MetaData::Equip* meta = nullptr;
    float explosion_range = 1;
    float atk = 0;

    void Done();
    float GetAtk() { return atk; }
};
