#pragma once

namespace MetaData
{
    struct Map;
    struct SafeArea;
    struct SafeAreaPos;
    struct Equip;
    struct EquipUpgrade;
    struct MapTplThing;
}

struct GasData
{
    GasMode_e gas_mode = GasInactive;
    a8::Vec2 pos_old;
    a8::Vec2 pos_old_bk;
    a8::Vec2 pre_pos_old;
    a8::Vec2 pos_new;
    float rad_old = 0.0f;
    float rad_new = 0.0f;
    float gas_progress = 0.0f;
    long long gas_start_frameno = 0;
    MetaData::SafeArea* old_area_meta = nullptr;
    MetaData::SafeArea* new_area_meta = nullptr;
    MetaData::SafeAreaPos* pos_list = nullptr;
    bool is_last_gas = false;
    int gas_count = 0;
};
