#include "precompile.h"
#include "global.h"

int g_hint_flags = 0;

int Global::g_nowtime = time(nullptr);
ColliderComponent* Global::last_collider = nullptr;

bool IsValidSlotId(int slot_id)
{
    return slot_id >= 0 && slot_id < IS_END;
}

bool IsValidBuffEffect(int buff_effect)
{
    return buff_effect > kBET_Begin && buff_effect < (kBET_End + 10);
}

bool IsValidHumanAttr(int attr_type)
{
    return attr_type > kHAT_Begin && attr_type < kHAT_End;
}

bool IsValidCondBuff(int cond)
{
    return cond >= 0 && cond < kCondBuffEnd;
}

bool IsValidWeaponOpt(int opt)
{
    return opt >= 0 && opt < kWeaponOptEnd;
}

bool IsValidBuffOpt(int opt)
{
    return opt >= 0 && opt < kBuffOptEnd;
}
