#pragma once

#include "microtask.h"

namespace MetaData
{
    struct Buff;
    struct Equip;
}

class Room;
class Player;
class SmokeMiTask : public MicroTask
{
 public:
    Room* room = nullptr;
    a8::Vec2 bomb_pos;
    std::set<Player*> player_set;
    MetaData::Buff* buff_meta = nullptr;
    MetaData::Equip* gun_meta = nullptr;

    void Check();
    void Done();
};
